<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Unit Conversion and Dimensional Analysis Library: units::unit&lt; Conversion, BaseUnit, PiExponent, Translation &gt; Struct Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Unit Conversion and Dimensional Analysis Library
   &#160;<span id="projectnumber">2.3.0</span>
   </div>
   <div id="projectbrief">A compile-time c++14 unit conversion library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespaceunits.html">units</a></li><li class="navelem"><a class="el" href="structunits_1_1unit.html">unit</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="structunits_1_1unit-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">units::unit&lt; Conversion, BaseUnit, PiExponent, Translation &gt; Struct Template Reference<div class="ingroups"><a class="el" href="group___unit_types.html">Unit Types</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Type representing an arbitrary unit.  
 <a href="structunits_1_1unit.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="units_8h_source.html">units.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for units::unit&lt; Conversion, BaseUnit, PiExponent, Translation &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structunits_1_1unit.png" alt=""/>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a80a7bfacd08e44750f2f00789705c7b4"><td class="memItemLeft" align="right" valign="top"><a id="a80a7bfacd08e44750f2f00789705c7b4"></a>
typedef units::traits::unit_traits&lt; BaseUnit &gt;::base_unit_type&#160;</td><td class="memItemRight" valign="bottom"><b>base_unit_type</b></td></tr>
<tr class="separator:a80a7bfacd08e44750f2f00789705c7b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f2b640f43170629369706775699fdbe"><td class="memItemLeft" align="right" valign="top"><a id="a0f2b640f43170629369706775699fdbe"></a>
typedef std::ratio_multiply&lt; typename BaseUnit::conversion_ratio, Conversion &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>conversion_ratio</b></td></tr>
<tr class="separator:a0f2b640f43170629369706775699fdbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aadc106afe2fedc05c154ff9f2c16025f"><td class="memItemLeft" align="right" valign="top"><a id="aadc106afe2fedc05c154ff9f2c16025f"></a>
typedef std::ratio_add&lt; typename BaseUnit::pi_exponent_ratio, PiExponent &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>pi_exponent_ratio</b></td></tr>
<tr class="separator:aadc106afe2fedc05c154ff9f2c16025f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0cdaa6959c83b6ddb1038d99a31e7814"><td class="memItemLeft" align="right" valign="top"><a id="a0cdaa6959c83b6ddb1038d99a31e7814"></a>
typedef std::ratio_add&lt; std::ratio_multiply&lt; typename BaseUnit::conversion_ratio, Translation &gt;, typename BaseUnit::translation_ratio &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>translation_ratio</b></td></tr>
<tr class="separator:a0cdaa6959c83b6ddb1038d99a31e7814"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;class Conversion, class BaseUnit, class PiExponent = std::ratio&lt;0&gt;, class Translation = std::ratio&lt;0&gt;&gt;<br />
struct units::unit&lt; Conversion, BaseUnit, PiExponent, Translation &gt;</h3>

<p>Type representing an arbitrary unit. </p>
<p><code>unit</code> types are used as tags for the <code>conversion</code> function. They are <em>not</em> containers (see <code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> for a container class). Each unit is defined by:</p>
<ul>
<li>A <code>std::ratio</code> defining the conversion factor to the base unit type. (e.g. <code>std::ratio&lt;1,12&gt;</code> for inches to feet)</li>
<li>A base unit that the unit is derived from (or a unit category. Must be of type <code>unit</code> or <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a></code>)</li>
<li>An exponent representing factors of PI required by the conversion. (e.g. <code>std::ratio&lt;-1&gt;</code> for a radians to degrees conversion)</li>
<li>a ratio representing a datum translation required for the conversion (e.g. <code>std::ratio&lt;32&gt;</code> for a fahrenheit to celsius conversion)</li>
</ul>
<p>Typically, a specific unit, like <code>meters</code>, would be implemented as a type alias of <code>unit</code>, i.e. <code>using meters = unit&lt;std::ratio&lt;1&gt;, <a class="el" href="namespaceunits_1_1category.html#a3dede37fafca5ea729d3c4332ebc3901" title="Represents an SI base unit of length.">units::category::length_unit</a></code>, or <code>using inches = unit&lt;std::ratio&lt;1,12&gt;, feet&gt;</code>. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">Conversion</td><td>std::ratio representing scalar multiplication factor. </td></tr>
    <tr><td class="paramname">BaseUnit</td><td>Unit type which this unit is derived from. May be a <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a></code>, or another <code>unit</code>. </td></tr>
    <tr><td class="paramname">PiExponent</td><td>std::ratio representing the exponent of pi required by the conversion. </td></tr>
    <tr><td class="paramname">Translation</td><td>std::ratio representing any datum translation required by the conversion. </td></tr>
  </table>
  </dd>
</dl>
</div><hr/>The documentation for this struct was generated from the following file:<ul>
<li>/mnt/e/workspace/units-master/include/<a class="el" href="units_8h_source.html">units.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Oct 3 2020 11:16:53 for Unit Conversion and Dimensional Analysis Library by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
